
package net.sf.dc.console.audiocd;

import javax.swing.JDialog;

/**
 * TODO: create this
 */
public class ImportCoversDialog extends JDialog {
/** private CoverDownloader coverDownloader;
    
    private String selectedImage = "";
    
    private final String artist;
    private final String title;
    
    private final Vector vCovers = new Vector();
    private final Vector vBase64Images = new Vector();
    
    private final DCList listCovers = new DCList();
    private final JProgressBar progressBar = new JProgressBar();
    private final JTextArea textLog = ComponentFactory.getTextArea();
    
    private final AudioCD audioCD;
    private final Color color = 
        Settings.getValueAsColor(Repository.settings.stColor);
    
    public ImportCoversDialog(AudioCD audioCD) {
        setModal(true);
        
        this.audioCD = audioCD;
        this.artist = audioCD.getValue(AudioCD._B_ARTIST).toString();
        this.title = audioCD.getValue(AudioCD._A_TITLE).toString();
        
        addWindowListener(new WindowAdapter() {
            public void windowClosing(WindowEvent e) {
                close();
            }
        });            
        
        if (artist.equals("") ||title.equals("")) {
        	new MessageBox("Cannot download covers as the artist name or the " +
                           "title is unknown!", MessageBox._WARNING);
        } else {
        	buildDialog();
            search();

            setSize(200, 400);            
            Dimension dim = Utilities.getCenteredWindowLocation(getSize());
            setLocation(dim.width, dim.height);
            setVisible(true);
        }
    }
    
    private void close() {
    	stop();
        setModal(false);
        setVisible(false);
        dispose();
    }
    
    public void stop() {
        progressBar.setValue(0);
        if (coverDownloader != null) {
            coverDownloader.stopSearch();
        }
        vBase64Images.clear();
        vCovers.clear();
    }    
    
    public void addCover(String base64Image) {
        JPanel panel = new JPanel(new FlowLayout(FlowLayout.CENTER));
        PictureField picField = ComponentFactory.getPictureField(true, true, false);
        picField.setValue(base64Image);
        panel.add(picField);
        
        vCovers.addElement(panel);
        vBase64Images.addElement(base64Image);
        
        listCovers.setListData(vCovers);
        base64Image = null;
        pack();
        
        Dimension dim = Utilities.getCenteredWindowLocation(getSize());        
        setLocation(dim.width, dim.height);
    }    
    
    public void search() {
        try {
            addMessage("Staring search for " + artist + ", " + title);
        	coverDownloader = new CoverDownloader(artist, title, this);
            coverDownloader.start();
        } catch (Exception exp) {
        	Messages.setMessage(exp);
            new MessageBox("There was an error while retrieving the covers: " + exp.getMessage(),
                           MessageBox._ERROR);
        }
    }
    
    /**
     * Initializes the progress bar. Sets the maximum value
     * @param maxValue maximum value
     */
 /*   public void initProgressBar(int maxValue) {
        progressBar.setValue(0);
        progressBar.setMaximum(maxValue);
    }
    
    /**
     * Updates the value of the progress bar
     * @param value progress value
     */
 /*   public void updateProgressBar(int value) {
        progressBar.setValue(value);
    }
    
    /**
     * Adds a log message
     * @param message message to be added
     */
 /*   public void addMessage(String message) {
        textLog.insert(message + '\n', 0);
    }
    
    private void saveSelected() {
    	int index = listCovers.getSelectedIndex();
        selectedImage = vBase64Images.elementAt(index).toString();
        close();
    }
    
    public String getSelectedImage() {
        return selectedImage;
    } */
    
  /*  private void buildDialog() {
        getContentPane().setLayout(Layout.getGBL());
        getContentPane().setBackground(color);
        JPanel panelCovers = new JPanel();
        panelCovers.setLayout(Layout.getGBL());
        panelCovers.setBackground(color);
        JPanel panelActions = new JPanel(false);
        panelActions.setLayout(Layout.getGBL());
        panelActions.setBackground(color);        
        JPanel panelProgress = new JPanel(false);
        panelProgress.setLayout(Layout.getGBL());
        panelProgress.setBackground(color);
        JPanel panelLog = new JPanel(false);
        panelLog.setLayout(Layout.getGBL());
        panelLog.setBackground(color);
        
        //**********************************************************
        //Covers panel
        //**********************************************************
        panelCovers.add(listCovers, Layout.getGBC( 0, 0, 1, 1, 1.0, 1.0
                       ,GridBagConstraints.NORTHWEST, GridBagConstraints.BOTH,
						new Insets(5, 5, 5, 5), 0, 0));
        
        //**********************************************************
        //Action panel
        //**********************************************************
        JButton buttonSave = ComponentFactory.getButton(
        		                Resources.getText(DCLabels.lblTransfer));
        JButton buttonStop = ComponentFactory.getButton(
                                Resources.getText(DCLabels.lblStop));
        JButton buttonClose = ComponentFactory.getButton(
        		                Resources.getText(DCLabels.lblClose));
        
        buttonClose.addActionListener(new CloseAction());
        buttonSave.addActionListener(new SaveAction());
        buttonStop.addActionListener(new StopAction());
        
        panelActions.add(buttonSave, Layout.getGBC( 0, 0, 1, 1, 0.0, 0.0
                       ,GridBagConstraints.NORTHWEST, GridBagConstraints.HORIZONTAL,
                        new Insets(5, 5, 5, 5), 0, 0));
        panelActions.add(buttonStop, Layout.getGBC( 1, 0, 1, 1, 0.0, 0.0
                        ,GridBagConstraints.NORTHWEST, GridBagConstraints.HORIZONTAL,
                         new Insets(5, 5, 5, 5), 0, 0));        
        panelActions.add(buttonClose, Layout.getGBC(2, 0, 1, 1, 0.0, 0.0
                        ,GridBagConstraints.NORTHWEST, GridBagConstraints.HORIZONTAL,
                         new Insets(5, 5, 5, 5), 0, 0));        
        
        //**********************************************************
        //Progress panel
        //**********************************************************
        panelProgress.add(progressBar, Layout.getGBC( 0, 1, 1, 1, 1.0, 1.0
                         ,GridBagConstraints.NORTHWEST, GridBagConstraints.HORIZONTAL,
                          new Insets(5, 5, 5, 5), 0, 0));  
        
        //**********************************************************
        //Log Panel
        //**********************************************************
        JScrollPane scrollPane = new JScrollPane(textLog);
        scrollPane.setHorizontalScrollBarPolicy(JScrollPane.HORIZONTAL_SCROLLBAR_NEVER);
        panelLog.add(scrollPane, Layout.getGBC( 0, 1, 1, 1, 1.0, 1.0
                    ,GridBagConstraints.NORTHWEST, GridBagConstraints.BOTH,
                     new Insets(5, 5, 5, 5), 0, 0));          
        
        getContentPane().add(panelCovers,   Layout.getGBC( 0, 0, 1, 1, 40.0, 40.0
                            ,GridBagConstraints.NORTHWEST, GridBagConstraints.BOTH,
							 new Insets(5, 5, 5, 5), 0, 0));
        getContentPane().add(panelActions,  Layout.getGBC( 0, 1, 1, 1, 1.0, 1.0
                            ,GridBagConstraints.NORTHWEST, GridBagConstraints.HORIZONTAL,
                             new Insets(5, 5, 5, 5), 0, 0));
        getContentPane().add(panelProgress, Layout.getGBC( 0, 2, 1, 1, 1.0, 1.0
                            ,GridBagConstraints.NORTHWEST, GridBagConstraints.HORIZONTAL,
							 new Insets(5, 5, 5, 5), 0, 0));
        getContentPane().add(panelLog,      Layout.getGBC( 0, 3, 1, 1, 10.0, 10.0
                            ,GridBagConstraints.NORTHWEST, GridBagConstraints.BOTH,
                             new Insets(5, 5, 5, 5), 0, 0));        
        
        setResizable(true);        
        pack();
    }
    
    private class StopAction implements ActionListener {
        public void actionPerformed(ActionEvent e) {
            stop();   
        }
    }
    
    private class CloseAction implements ActionListener {
        public void actionPerformed(ActionEvent e) {
            close();   
        }
    }     
    
    private class SaveAction implements ActionListener {
        public void actionPerformed(ActionEvent e) {
            saveSelected();   
        }
    }     */
}
