/******************************************************************************
 *                                     __                                     *
 *                              <-----/@@\----->                              *
 *                             <-< <  \\//  > >->                             *
 *                               <-<-\ __ /->->                               *
 *                               Data /  \ Crow                               *
 *                                   ^    ^                                   *
 *                       (c) 2003 Robert-Jan van der Waals                    *
 *                             rwaals@anytimenow.com                          *
 *                                                                            *
 *                                                                            *
 *       This library is free software; you can redistribute it and/or        *
 *        modify it under the terms of the GNU Lesser General Public          *
 *       License as published by the Free Software Foundation; either         *
 *     version 2.1 of the License, or (at your option) any later version.     *
 *                                                                            *
 *      This library is distributed in the hope that it will be useful,       *
 *      but WITHOUT ANY WARRANTY; without even the implied warranty of        *
 *     MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU       *
 *           Lesser General Public License for more details.                  *
 *                                                                            *
 *     You should have received a copy of the GNU Lesser General Public       *
 *    License along with this library; if not, write to the Free Software     *
 *  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307 USA   *
 *                                                                            *
 ******************************************************************************/

package net.sf.dc.db;

import java.util.Vector;

/**
 * Specifies on which table, with which fields, the query is run
 *
 * @author Robert-Jan van der Waals
 * @since 1.3
 * @version 0.50
 */
public class QueryWhat {

    private Vector vColumns = new Vector();
    private String sTableName;
    private String sSelectTableDef;

    /**
     * Initializes the query what
     * @param columns the column names of the database
     * @param sTableName database name
     * @param sSelectTableDef join definition for parent <> child
     */
    public QueryWhat(String[] columns, String sTableName, String sSelectTableDef) {
        for (int i = 0; i < columns.length; i++) {
            vColumns.add(columns[i])   ;
        }
        vColumns.trimToSize();
        this.sTableName = sTableName;
        this.sSelectTableDef = sSelectTableDef;
    }

    /**
     * Returns the list of column names
     */
    public Vector getColumns() {
        return vColumns;
    }

    public String getSelectTableDef() {
    	return sSelectTableDef;
    }
    
    /**
     * Returns the database tablename
     */
    public String getTableName() {
        return sTableName;
    }
}
