/******************************************************************************
 *                                     __                                     *
 *                              <-----/@@\----->                              *
 *                             <-< <  \\//  > >->                             *
 *                               <-<-\ __ /->->                               *
 *                               Data /  \ Crow                               *
 *                                   ^    ^                                   * 
 *                           sub-project: Utilites                            *
 *                       (c) 2003 Robert-Jan van der Waals                    *
 *                             rwaals@anytimenow.com                          *
 *                                                                            *
 *                                                                            *
 *       This library is free software; you can redistribute it and/or        *
 *        modify it under the terms of the GNU Lesser General Public          *
 *       License as published by the Free Software Foundation; either         *
 *     version 2.1 of the License, or (at your option) any later version.     *
 *                                                                            *
 *      This library is distributed in the hope that it will be useful,       *
 *      but WITHOUT ANY WARRANTY; without even the implied warranty of        *
 *     MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU       *
 *           Lesser General Public License for more details.                  *
 *                                                                            *
 *     You should have received a copy of the GNU Lesser General Public       *
 *    License along with this library; if not, write to the Free Software     *
 *  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307 USA   *
 *                                                                            *
 ******************************************************************************/

package net.sf.ext.util;

/**
 * Simple string utilities
 *
 * @author Robert-Jan van der Waals
 * @since 1.3
 * @version 0.50
 */
public class StringUtils {
	
	public static String replaceAll(String input, String replaceString, String replaceWith) {
        int replaceBegin = input.indexOf(replaceString);
        
		while (replaceBegin > -1) {
            int replaceEnd = replaceBegin + replaceString.length();
            input = input.substring(0, replaceBegin) + replaceWith +
                    input.substring(replaceEnd); 
            replaceBegin = input.indexOf(replaceString);
		}
		return input;
	}
    
    public static String getValueBetweenStrings(String start, String end, String sSource) {
        String s = "";
        try {
            int indexBegin = sSource.indexOf(start);
            
            if (indexBegin != -1) {
                s = sSource.substring(indexBegin + start.length());
            }
            
            int indexEnd = s.indexOf(end);
            
            if (indexEnd != -1) {
                s = s.substring(0, indexEnd);
            }
        } catch (Exception ingnore) {}
        
        return s;
    }
    
    public static boolean isEmpty(String input) {
        if (input == null || input.trim().equals("")) {
            return true;   
        }
        return false;
    }
    
    /**
     * Clean the string of any unwanted characters
     * @param s string to clean
     */
    public static String convertHttpString(String s) {
        if ((s.startsWith("\"")) && (s.endsWith("\""))) {
            s = s.substring(1, s.length() - 1);
        }
        
        s = StringUtils.replaceAll(s, "&lt;I>", "");
        s = StringUtils.replaceAll(s, "&lt;/I>", "");
        s = StringUtils.replaceAll(s, "&lt;p>", "");
        s = StringUtils.replaceAll(s, "&lt;/p>", "");
        s = StringUtils.replaceAll(s, "&lt;/b>", "");
        s = StringUtils.replaceAll(s, "&lt;b>", "\n\n");
        s = StringUtils.replaceAll(s, "&lt;li>", "\n");
        s = StringUtils.replaceAll(s, "&lt;ul>", "\n");
        s = StringUtils.replaceAll(s, "&lt;/ul>", "");
        s = StringUtils.replaceAll(s, "&lt;ul>", "\n");
        s = StringUtils.replaceAll(s, "&lt;i>", "");
        s = StringUtils.replaceAll(s, "&lt;B>", "");
        s = StringUtils.replaceAll(s, "&lt;/B>", "");
        s = StringUtils.replaceAll(s, "&lt;/i>", "");
        s = StringUtils.replaceAll(s, "&amp;#146;", "`");
        s = StringUtils.replaceAll(s, "&#192;", "");
        s = StringUtils.replaceAll(s, "&#193;", "");
        s = StringUtils.replaceAll(s, "&#194;", "");
        s = StringUtils.replaceAll(s, "&#195;", "");
        s = StringUtils.replaceAll(s, "&#196;", "");
        s = StringUtils.replaceAll(s, "&#197;", "");
        s = StringUtils.replaceAll(s, "&#198;", "");
        s = StringUtils.replaceAll(s, "&#199;", "");
        s = StringUtils.replaceAll(s, "&#200;", "");
        s = StringUtils.replaceAll(s, "&#201;", ""); 
        s = StringUtils.replaceAll(s, "&#202;", ""); 
        s = StringUtils.replaceAll(s, "&#203;", "");
        s = StringUtils.replaceAll(s, "&#204;", "");
        s = StringUtils.replaceAll(s, "&#205;", ""); 
        s = StringUtils.replaceAll(s, "&#206;", ""); 
        s = StringUtils.replaceAll(s, "&#207;", ""); 
        s = StringUtils.replaceAll(s, "&#208;", ""); 
        s = StringUtils.replaceAll(s, "&#209;", ""); 
        s = StringUtils.replaceAll(s, "&#210;", ""); 
        s = StringUtils.replaceAll(s, "&#211;", ""); 
        s = StringUtils.replaceAll(s, "&#212;", ""); 
        s = StringUtils.replaceAll(s, "&#213;", ""); 
        s = StringUtils.replaceAll(s, "&#214;", ""); 
        s = StringUtils.replaceAll(s, "&#215;", ""); 
        s = StringUtils.replaceAll(s, "&#216;", ""); 
        s = StringUtils.replaceAll(s, "&#217;", ""); 
        s = StringUtils.replaceAll(s, "&#218;", ""); 
        s = StringUtils.replaceAll(s, "&#219;", ""); 
        s = StringUtils.replaceAll(s, "&#220;", ""); 
        s = StringUtils.replaceAll(s, "&#221;", ""); 
        s = StringUtils.replaceAll(s, "&#222;", ""); 
        s = StringUtils.replaceAll(s, "&#223;", "");
        s = StringUtils.replaceAll(s, "&#224;", ""); 
        s = StringUtils.replaceAll(s, "&#225;", ""); 
        s = StringUtils.replaceAll(s, "&#226;", ""); 
        s = StringUtils.replaceAll(s, "&#227;", ""); 
        s = StringUtils.replaceAll(s, "&#228;", ""); 
        s = StringUtils.replaceAll(s, "&#229;", ""); 
        s = StringUtils.replaceAll(s, "&#230;", ""); 
        s = StringUtils.replaceAll(s, "&#231;", ""); 
        s = StringUtils.replaceAll(s, "&#232;", ""); 
        s = StringUtils.replaceAll(s, "&#233;", ""); 
        s = StringUtils.replaceAll(s, "&#234;", ""); 
        s = StringUtils.replaceAll(s, "&#235;", ""); 
        s = StringUtils.replaceAll(s, "&#236;", ""); 
        s = StringUtils.replaceAll(s, "&#237;", ""); 
        s = StringUtils.replaceAll(s, "&#238;", ""); 
        s = StringUtils.replaceAll(s, "&#239;", ""); 
        s = StringUtils.replaceAll(s, "&#240;", ""); 
        s = StringUtils.replaceAll(s, "&#241;", ""); 
        s = StringUtils.replaceAll(s, "&#242;", ""); 
        s = StringUtils.replaceAll(s, "&#243;", ""); 
        s = StringUtils.replaceAll(s, "&#244;", ""); 
        s = StringUtils.replaceAll(s, "&#245;", ""); 
        s = StringUtils.replaceAll(s, "&#246;", ""); 
        s = StringUtils.replaceAll(s, "&#247;", ""); 
        s = StringUtils.replaceAll(s, "&#248;", ""); 
        s = StringUtils.replaceAll(s, "&#249;", ""); 
        s = StringUtils.replaceAll(s, "&#250;", ""); 
        s = StringUtils.replaceAll(s, "&#251;", ""); 
        s = StringUtils.replaceAll(s, "&#252;", ""); 
        s = StringUtils.replaceAll(s, "&#253;", ""); 
        s = StringUtils.replaceAll(s, "&#254;", ""); 
        s = StringUtils.replaceAll(s, "&#255;", "");
        s = StringUtils.replaceAll(s, "&#338;", ""); 
        s = StringUtils.replaceAll(s, "&#339;", ""); 
        s = StringUtils.replaceAll(s, "&#352;", ""); 
        s = StringUtils.replaceAll(s, "&#353;", ""); 
        s = StringUtils.replaceAll(s, "&#376;", ""); 
        s = StringUtils.replaceAll(s, "&#402;", ""); 
        s = StringUtils.replaceAll(s, "&#8364;", ""); 
        s = StringUtils.replaceAll(s, "&#8482;", "");  
        s = StringUtils.replaceAll(s, "&lt;u", "");
        s = StringUtils.replaceAll(s, "&#34;", "`");
        s = StringUtils.replaceAll(s, "&lt;i>", "");
        s = StringUtils.replaceAll(s, "&#38;", "");
        s = StringUtils.replaceAll(s, "&#34;", "");
        s = StringUtils.replaceAll(s, "&amp;", "");
        s = StringUtils.replaceAll(s, "&lt;/u", "");
        s = StringUtils.replaceAll(s, "#133", "");
        s = StringUtils.replaceAll(s, "&lt;P", "");
        s = StringUtils.replaceAll(s, "#151;", " - ");
        
        return s;         
    }    
}
